C1/ASM ;	C1/ASM		"CARNIVAL"
 	ORG	4000H
 VIDEO	EQU	3C00H
 STACK	EQU	40F8H
 	JP	R8		;RESTART 8H
 	JP	R10		;10H
 	JP	R18		;18H
 	JP	R20		;20H
 	JP	R28		;28H
 	JP	R30		;30H
 	JP	TASK		;INTERRUPT ROUTINE
 ;	FLAGS AND STACK UP TO 40FFH
 	ORG	4100H
 ENTRY	DI
 	LD	SP,STACK	;SETUP STACK
 	LD	HL,RESTARTS	;SETUP RESTART TABLE
 	LD	DE,4000H	;WHERE IT GOES
 	LD	BC,21		;21 BYTES IN TABLE
 	LDIR			;MOVE 'EM
 	IM	1		;SETUP INTERRUPTS
 	CALL	CLS		;CLEAR THE SCREEN
 ;	EI			;ENABLE THE INTERRUPTS
 TRYIT	CALL	MOVE		;MOVE THE PIECES
 	CALL	FIXTBL		;ADJUST TABLE
 	JR	TRYIT
 START	CALL	TITLEPAGE	;PRINT TITLE PAGE
 ;GAME	START HERE  ********************************
 CLS	XOR	A		;ZERO ACCUM.
 	OUT	(0FFH),A	;64 CHAR SIZE
 	LD	HL,VIDEO	;VIDEO SCREEN
 	LD	DE,VIDEO+1	;NEXT BYTE
 	LD	(HL),' '	;PUT A SPACE IN CORNER
 	LD	BC,1023		;BYTES TO MOVE -1
 	LDIR			;CLEAR THE SCREEN
 	RET			;DONE
 MOVE	LD	IX,TABLE1	;POINT TO ITEM TABLE
 LOOP3	LD	A,(IX)		;GET PIECE TYPE
 	OR	A		;SET FLAGS
 	RET	Z		;END OF TABLE
 	BIT	7,(IX)		;IF MOVING
 	JR	Z,NEXT1		;SKIP IF NOT
 	AND	7FH		;LOWER 7 BITS ONLY
 	DEC	A		;SET FOR TABLE
 	LD	L,A		;GIVE TO HL
 	LD	H,0		;HL=PIECE TYPE
 	ADD	HL,HL		;DOUBLE IT
 	ADD	HL,HL		;X 4
 	ADD	HL,HL		;X 8
 	ADD	HL,HL		;X 16
 	LD	BC,TABLE2	;POINT TO DRAW TABLE
 	ADD	HL,BC		;POINT TO PIECE
 	CALL	MOVEIT		;MOVE THE PIECE
 NEXT1	LD	BC,6		;DISPLACEMENT TO NEXT ONE
 	ADD	IX,BC		;ADD TO INDEX
 	JR	LOOP3		;DO NEXT PIECE
 ERASE	BIT	7,(HL)		;ANYTHING ?
 	RET	Z		;SKIP IT
 	BIT	0,(HL)		;BIT TO BE ON ?
 	CALL	NZ,RESET	;BIT IS ON ?
 BITCON	BIT	4,(HL)		;MOVE UP ?
 	JR	NZ,MUP		;DO IT
 	BIT	3,(HL)		;MOVE DOWN ?
 	JR	NZ,MDOWN		;DO IT
 	BIT	6,(HL)		;MOVE RIGHT ?
 	JR	NZ,MRIGHT	;DO IT
 	BIT	5,(HL)		;MOVE LEFT ?
 	JR	NZ,MLEFT	;DO IT
 PGMERR	LD	HL,MSG1
 	CALL	DISPLY
 WAIT	CALL	2BH
 	OR	A
 	JR	Z,WAIT
 	JP	ENTRY
 MSG1	DB	1CH,1FH,'PROGRAM ERROR',0
 DISPLY	LD	A,(HL)
 	OR	A
 	INC	HL
 	RET	Z
 	CALL	33H
 	JR	DISPLY
 MUP	DEC	D		;MOVE UP 1 BIT
 	RET			;DONE
 MDOWN	INC	D		;MOVE DOWN
 	RET			;DONE
 MRIGHT	INC	E		;MOVE RIGHT
 	RET			;DONE
 MLEFT	DEC	E		;MOVE LEFT
 	RET			;DONE
 MOVEIT	LD	B,16		;ALLOW 16 CHARACTERS
 	LD	E,(IX+1)	;GET LSB POSITION
 	LD	D,(IX+2)	;GET MSB POSITION
 	PUSH	HL		;SAVE TABLE POINTER
 MOVELP	CALL	ERASE		;ERASE OLD
 	INC	HL		;BUMP DATA POINTER
 	DJNZ	MOVELP		;DO IT ALL
 	LD	A,(IX+1)	;GET OLD ROW
 	ADD	A,(IX+3)	;NEW POSITION
 	LD	(IX+1),A	;SAVE IT
 	LD	E,A
 	LD	A,(IX+2)	;GET OLD COLUMN
 	ADD	A,(IX+4)
 	LD	(IX+2),A
 	LD	D,A
 	LD	B,16
 	POP	HL		;RESTORE TABLE POINTER
 LOOP4	CALL	ADJUST		;DRAW NEW POSITION
 	INC	HL		;BUMP TABLE
 	DJNZ	LOOP4		;FINISH IT UP
 	RET			;DONE WITH PIECE
 ADJUST	BIT	7,(HL)		;ANYTHING ?
 	RET	Z		;SKIP IT
 	BIT	0,(HL)		;BIT TO BE ON ?
 	CALL	NZ,SET		;SET THE BIT
 	JR	BITCON		;CONTINUE BIT CHECK
 SET	LD	A,0C6H		;SET B,(HL) OPCODE
 	JR	SETGO
 RESET	LD	A,86H		;RESET B,(HL) OPCODE
 	JR	SETGO
 POINT	LD	A,46H		;BIT B,(HL) OPCODE
 SETGO	PUSH	HL		;SAVE REGISTERS
 	PUSH	DE
 	PUSH	BC
 	LD	(INST1),A	;CREATE INSTRUCTION
 	CALL	ADJPNT		;CHECK VIDEO BOUNDRY
 	LD	A,D		;GET Y COORDINATE
 	LD	B,-1
 LOOP5	INC	B		;SUCCESIVE SUBS
 	SUB	3		;  FOR DIV. BY 3
 	JP	P,LOOP5		;GO IF NOT MINUS
 	ADD	A,3		;YQ IN B, YR IN A
 	SLA	A		;YR * 2
 	LD	C,A		;SAVE IT
 	LD	L,B		;YQ TO L
 	LD	H,0		;YQ IN HL
 	LD	B,6		;CNT FOR MUL. BY 64
 LOOP6	ADD	HL,HL		;YQ * 2
 	DJNZ	LOOP6		;GO IF NOT YQ * 64
 	LD	D,0		;DE HAS X
 	SRL	E		;XQ
 	JR	NC,CONT3	;GO IF XR NE 1
 	INC	C		;C HAS YR * 2 + XR
 CONT3	ADD	HL,DE		;HL = YQ * 2 + XQ
 	LD	DE,VIDEO	;START OF DISPLAY
 	ADD	HL,DE		;HL = POSITION
 	SLA	C		;ALIGN TO FIELD
 	SLA	C
 	SLA	C
 	LD	A,(INST1)	;GET INSTRUCTION
 	ADD	A,C		;SET FIELD
 	LD	(INST1),A	;PUT IT BACK
 	DB	0CBH		;BIT SET/TEST/RESET
 INST1	DB	0		;FILLED IN
 	SET	7,(HL)		;FOR GRAPHICS
 	POP	BC		;RESTORE EVERYTHING
 	POP	DE
 	POP	HL
 	RET			;DONE WITH COMMAND
 TABLE2	EQU	$		;PIECE DRAW TABLE
 GUN	DB	0C1H,0C1H,0C0H,90H,0A1H,0A1H,0A1H,89H
 	DB	0C1H,81H,0,0,0,0,0,0
 PIECE1	DB	0C1H,0C0H,90H,0A1H,0A1H,0A1H,0A1H,89H
 	DB	0C0H,0C0H,0C1H,88H,0A1H,0A0H,81H,0
 PIECE2	DB	0C1H,88H,0A1H,0A0H,0A1H,88H,0C1H,0C0H
 	DB	0C1H,0C0H,89H,0A0H,0A1H,81H,0,0
 PIECE3	DB	89H,89H,0C1H,0C1H,89H,0A1H,0A0H,0A0H
 	DB	0A0H,91H,0C1H,81H,0,0,0,0
 ADJPNT	LD	A,D		;GET ROW POINTER
 	CP	6		;AT TOP BOUNDRY ?
 	JR	C,ATTOP		;YES
 	CP	39		;AT BOTTOM BOUNDRY ?
 	RET	C		;NOPE
 	SUB	38		;HOW FAR BELOW ?
 	LD	D,A		;RESET IT
 	LD	C,A		;TEMPORARY SAVE
 	LD	A,39		;BOTTOM POSITION
 	SUB	D		;NEW ROW POSITION
 	LD	D,A		;PUT IT BACK
 	DEC	E		;MOVE LEFT 4 COLUMNS
 	DEC	E
 	DEC	E
 	DEC	E
 	LD	A,E		;GET NEW ROW
 	CP	36		;HOW FAR LEFT ?
 	RET	NC		;NOT FAR ENOUGH
 	LD	A,5		;TOP POSITION
 	ADD	A,C		;NEW POSITION
 	LD	D,A		;PUT IT BACK
 	RET			;DONE
 ATTOP	SUB	6		;HOW FAR ABOVE ?
 	LD	C,A		;TEMP SAVE
 	LD	A,5		;TOP OF AREA
 	ADD	A,C		;NEW POSITION
 	LD	D,A		;RESET IT
 	DEC	E		;MOVE LEFT 4 COLUMNS
 	DEC	E
 	DEC	E
 	DEC	E		;NOW WE'RE ALL SET
 	RET
 TABLE1	EQU	$		;MOVMENT TABLE
 GUN1	DB	1		;PIECE TYPE
 	DB	0		;COLUMN POSITION
 	DB	21		;ROW POSITION
 	DB	0		;VERTICAL DIRECTION
 	DB	0		;HORIZONTAL DIRECTION
 	DB	0		;SCORE VALUE
 PC1	DB	2+80H
 	DB	92
 	DB	10
 	DB	1
 	DB	0
 	DB	100
 PC2	DB	3+80H
 	DB	83
 	DB	22
 	DB	-1
 	DB	0
 	DB	200
 PC3	DB	4+80H
 	DB	76
 	DB	33
 	DB	1
 	DB	0
 	DB	150
 	DB	0		;TERMINATOR
 TASK	RET			;SKIP FOR NOW
 FIXTBL	LD	IX,TABLE1	;MOVEMENT TABLE
 FIXCON	LD	A,(IX)		;GET A BYTE
 	OR	A		;SET FLAGS
 	RET	Z		;TERMINATOR
 	BIT	7,(IX)		;ACTIVE ?
 	JR	Z,NEXT2		;SKIP IF NOT
 	LD	A,(IX+1)	;GET ROW
 	CP	6		;AT TOP ?
 	JR	C,DOTOP		;YES
 	CP	39		;AT BOTTOM ?
 	JR	NC,DOBOT	;AT BOTTOM
 NEXT2	LD	BC,6
 	ADD	IX,BC
 	JR	FIXCON
 DOTOP	LD	A,1
 	LD	(IX+4),A
 	JR	NEXT2
 DOBOT	LD	A,-1
 	LD	(IX+4),A
 	JR	NEXT2
 	END	ENTRY
	JR	C,DOTOP		;YES
 	CP	39		;AT BOTTOM ?
 	JR	NC,DOBOT	;AT BOTTOM
 NEX